//
//  main.m
//  PDFSplitConsole
//
//  Created by Debenu Pty Ltd on 9/22/12.
//  Copyright (c) 2012 Debenu Pty Ltd. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Controller.h"

void printUsage();

int main(int argc, const char * argv[])
{
    NSAutoreleasePool* pool = [[NSAutoreleasePool alloc] init];
    
    NSArray* arguments = [[NSProcessInfo processInfo] arguments];
    
    if( [arguments count] != 3 ) {
        printUsage();
        return -1;
    }

    NSString* inputFilePath = [arguments objectAtIndex:1];
    NSString* outputFilePath = [arguments objectAtIndex:2];
    
    Controller* controller = [[[Controller alloc] init] autorelease];
    NSError* error = nil;

    if( ![controller createTextFromPDF:inputFilePath toPath:outputFilePath error:&error] ) {
        NSLog(@"%@", [error localizedDescription]);
        return -1;
    }

    NSLog(@"extracting text success!");
        
    [pool drain];
    
    return 0;
}

void printUsage()
{
    NSLog(@"Usage: pdftextconsole input_file output_file");
}
