//
//  Controller.m
//  PDFMerge
//
//  Created by Debenu Pty Ltd on 9/18/12.
//  Copyright (c) 2012 Debenu Pty Ltd. All rights reserved.
//

#import "Controller.h"
#import "DebenuPDFLibraryDylibClass1015.h"

@implementation Controller

- (BOOL)overlayWithFile1:(NSString*)file1 file2:(NSString*)file2 to:(NSString*)toFilePath error:(NSError**)error
{
    // extract text from pdf
    NSBundle* mainBundle = [NSBundle mainBundle];
    NSString* dylibPath = [[mainBundle executablePath] stringByDeletingLastPathComponent];
    
    dylibPath = [dylibPath stringByAppendingPathComponent:@"libDebenuPDFLibraryDylib1015.dylib"];
    
    DebenuPDFLibraryDylibClass1015* DQPL = [[[DebenuPDFLibraryDylibClass1015 alloc] initWithDylibFileName:dylibPath]autorelease];
    
    
    NSString* key = @"*** insert your license key here ***";
    
    if( [DQPL UnlockKey:key] != 1 ) {
        
        if( error != NULL ) {

            NSString* description = [NSString stringWithFormat:@"Failed to unlock DQPL with %@", key];
            
            *error = [NSError errorWithDomain:@"DQPLErrorDomain"
                                         code:0
                                     userInfo:[NSDictionary dictionaryWithObject:description forKey:NSLocalizedDescriptionKey]];
            
        }
        
        return NO;
    }
    
    if( [DQPL LoadFromFile:file1 :@""] != 1 ) {
        
        if( error != NULL ) {
            *error = [NSError errorWithDomain:@"DQPLErrorDomain"
                                         code:0
                                     userInfo:[NSDictionary dictionaryWithObject:[NSString stringWithFormat:@"Failed to open %@", file1] forKey:NSLocalizedDescriptionKey]];
            
        }
        
        return NO;
    }
    
    int firstPDF = [DQPL SelectedDocument];
    
    if( [DQPL LoadFromFile:file2 :@""] != 1 ) {
        
        if( error != NULL ) {
            *error = [NSError errorWithDomain:@"DQPLErrorDomain"
                                         code:0
                                     userInfo:[NSDictionary dictionaryWithObject:[NSString stringWithFormat:@"Failed to open %@", file2] forKey:NSLocalizedDescriptionKey]];
            
        }
        
        return NO;
    }
    
    int secondPDF = [DQPL SelectedDocument];

    [DQPL SelectDocument:firstPDF];
    
    if( [DQPL MergeDocument:secondPDF] != 1 ) {
        
        if( error != NULL ) {
            *error = [NSError errorWithDomain:@"DQPLErrorDomain"
                                         code:0
                                     userInfo:[NSDictionary dictionaryWithObject:[NSString stringWithFormat:@"Failed to combine %@ and %@", file1, file2] forKey:NSLocalizedDescriptionKey]];
            
        }
        
        return NO;
    }
    
    // Capture the last page in the merged document.
    // After the page has been captured in memory it will be
    // automatically deleted from the document.
    
    int capturedPageID = [DQPL CapturePage:[DQPL PageCount]];
    
    [DQPL SelectDocument:firstPDF];

    // Then loop through each page in the selected
    // document and overlay each page with the
    // page that was captured previous.
    
    int pageCount = [DQPL PageCount];
    for( int i = 0; i < pageCount; ++i ) {
        
        [DQPL SelectPage:i];
        
        // Get page height and width
        
        int pageHeight = [DQPL PageHeight];
        int pageWidth = [DQPL PageWidth];
        
        // Draw the captured page onto the currently selected page
        [DQPL DrawCapturedPage:capturedPageID :0 :pageHeight :pageWidth :pageHeight];
    }
    
    if( [DQPL SaveToFile:toFilePath] != 1 ) {
        
        if( error != NULL ) {
            *error = [NSError errorWithDomain:@"DQPLErrorDomain"
                                         code:0
                                     userInfo:[NSDictionary dictionaryWithObject:[NSString stringWithFormat:@"Failed to save combined PDF to %@", toFilePath] forKey:NSLocalizedDescriptionKey]];
            
        }
        
        return NO;
    }
    
    return YES;
}

@end
