//
//  main.m
//  PDFSplitConsole
//
//  Created by Debenu Pty Ltd on 9/22/12.
//  Copyright (c) 2012 Debenu Pty Ltd. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Controller.h"

void printUsage();

int main(int argc, const char * argv[])
{
    NSAutoreleasePool* pool = [[NSAutoreleasePool alloc] init];
    
    NSArray* arguments = [[NSProcessInfo processInfo] arguments];
        
    if( [arguments count] < 4 ) {
        printUsage();
        return -1;
    }
    
    NSString* input_file1 = [arguments objectAtIndex:1];
    NSString* input_file2 = [arguments objectAtIndex:2];
    NSString* dest_file = [arguments objectAtIndex:3];
    
    Controller* overlayController = [[[Controller alloc] init] autorelease];
    NSError* error = nil;
    
    if( ![overlayController overlayWithFile1:input_file1 file2:input_file2 to:dest_file error:&error] ) {
        NSLog(@"%@", [error localizedDescription]);
        return -1;
    }

    NSLog(@"overlay success!");
        
    [pool drain];
    
    return 0;
}

void printUsage()
{
    NSLog(@"Usage: pdfoverlayconsole input_file1 input_file2 output_file");
}
